# coding: utf-8

"""
    Cirro Data

    Cirro Data Platform service API

    The version of the OpenAPI document: latest
    Contact: support@cirro.bio
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List
from pydantic import BaseModel, StrictBool, StrictStr
from pydantic import Field
from cirro_api_client.models.billing_method import BillingMethod
from cirro_api_client.models.contact import Contact
from cirro_api_client.models.customer_type import CustomerType
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class BillingAccount(BaseModel):
    """
    BillingAccount
    """ # noqa: E501
    id: StrictStr
    name: StrictStr
    organization: StrictStr
    contacts: List[Contact]
    customer_type: CustomerType = Field(alias="customerType")
    billing_method: BillingMethod = Field(alias="billingMethod")
    primary_budget_number: StrictStr = Field(alias="primaryBudgetNumber")
    owner: StrictStr
    shared_with: List[StrictStr] = Field(alias="sharedWith")
    is_archived: StrictBool = Field(alias="isArchived")
    __properties: ClassVar[List[str]] = ["id", "name", "organization", "contacts", "customerType", "billingMethod", "primaryBudgetNumber", "owner", "sharedWith", "isArchived"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of BillingAccount from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in contacts (list)
        _items = []
        if self.contacts:
            for _item in self.contacts:
                if _item:
                    _items.append(_item.to_dict())
            _dict['contacts'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of BillingAccount from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "name": obj.get("name"),
            "organization": obj.get("organization"),
            "contacts": [Contact.from_dict(_item) for _item in obj.get("contacts")] if obj.get("contacts") is not None else None,
            "customerType": obj.get("customerType"),
            "billingMethod": obj.get("billingMethod"),
            "primaryBudgetNumber": obj.get("primaryBudgetNumber"),
            "owner": obj.get("owner"),
            "sharedWith": obj.get("sharedWith"),
            "isArchived": obj.get("isArchived")
        })
        return _obj


