# coding: utf-8

"""
    Cirro Data

    Cirro Data Platform service API

    The version of the OpenAPI document: latest
    Contact: support@cirro.bio
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional
from pydantic import BaseModel, StrictInt, StrictStr
from pydantic import Field
from cirro_api_client.models.access_type import AccessType
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class FileAccessRequest(BaseModel):
    """
    FileAccessRequest
    """ # noqa: E501
    access_type: AccessType = Field(alias="accessType")
    dataset_id: Optional[StrictStr] = Field(default=None, alias="datasetId")
    token_lifetime_hours: Optional[StrictInt] = Field(default=None, alias="tokenLifetimeHours")
    __properties: ClassVar[List[str]] = ["accessType", "datasetId", "tokenLifetimeHours"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of FileAccessRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        # set to None if dataset_id (nullable) is None
        # and model_fields_set contains the field
        if self.dataset_id is None and "dataset_id" in self.model_fields_set:
            _dict['datasetId'] = None

        # set to None if token_lifetime_hours (nullable) is None
        # and model_fields_set contains the field
        if self.token_lifetime_hours is None and "token_lifetime_hours" in self.model_fields_set:
            _dict['tokenLifetimeHours'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of FileAccessRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "accessType": obj.get("accessType"),
            "datasetId": obj.get("datasetId"),
            "tokenLifetimeHours": obj.get("tokenLifetimeHours")
        })
        return _obj


