# coding: utf-8

"""
    Cirro Data

    Cirro Data Platform service API

    The version of the OpenAPI document: latest
    Contact: support@cirro.bio
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional
from pydantic import BaseModel, StrictStr
from pydantic import Field
from cirro_api_client.models.metric_record import MetricRecord
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class ProjectMetrics(BaseModel):
    """
    ProjectMetrics
    """ # noqa: E501
    project_id: StrictStr = Field(alias="projectId")
    costs: Optional[List[MetricRecord]] = Field(default=None, description="Costs by service by month")
    storage_metrics: Optional[List[MetricRecord]] = Field(default=None, description="Storage usage by tier by day", alias="storageMetrics")
    __properties: ClassVar[List[str]] = ["projectId", "costs", "storageMetrics"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of ProjectMetrics from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in costs (list)
        _items = []
        if self.costs:
            for _item in self.costs:
                if _item:
                    _items.append(_item.to_dict())
            _dict['costs'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in storage_metrics (list)
        _items = []
        if self.storage_metrics:
            for _item in self.storage_metrics:
                if _item:
                    _items.append(_item.to_dict())
            _dict['storageMetrics'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of ProjectMetrics from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "projectId": obj.get("projectId"),
            "costs": [MetricRecord.from_dict(_item) for _item in obj.get("costs")] if obj.get("costs") is not None else None,
            "storageMetrics": [MetricRecord.from_dict(_item) for _item in obj.get("storageMetrics")] if obj.get("storageMetrics") is not None else None
        })
        return _obj


